<template>
  <div class="text-white mt-1">
      <h1 class="mb-5">Top</h1>

      <div class="row">
          <div class="col-md-6 col-lg-3 col-sm-12 mb-3 song" v-for="song in songs">

              <div class="card flex-md-row box-shadow h-md-250 w-100 bg-dark playlist-bg" :id="'add'+song.id" v-if="showPlaylists && current_button === song.id">
                  <div class="card-header">
                      <button type="button" class="close" aria-label="Close" @click="hidePlaylists()">
                          <span aria-hidden="true" class="text-white">×</span>
                      </button>
                  </div>

                  <ul class="w-100 mt-3 pl">
                      <li v-for="playlist in playlists">
                          <button class="btn btn-outline-success text-white text-left w-75 playlist" @click="addToPlaylist(song.id, playlist.id)">
                            {{ playlist.name }}
                          </button>
                      </li>
                  </ul>
              </div>

              <div class="card flex-md-row box-shadow h-md-250 w-100 h-100 bg-dark playlist-bg" v-else :id="song.id">
                  <div class="card-body d-flex flex-column align-items-start">
                      <strong class="d-inline-block mb-2">MyMusic</strong>
                      <h5 class="mb-0 h-25">
                          <strong>
                              {{ song.title }}
                          </strong>
                      </h5>

                      <hr>

                      <div class="row w-100">
                          <div class="col-md-6 col-lg-6 col-sm-6">
                              <button class="btn btn-outline-success pause" :class="{ active : activeSong === song.id }" :id="'pause'+song.id" v-if="playing && activeSong === song.id" @click="pause" style="border-radius: 40px; height: 50px; width: 50px;">
                                  <b>&#9646;&#9646;</b>
                              </button>
                              <button class="btn btn-outline-success play" :class="{ active : activeSong === song.id }" :id="'song'+song.id" v-else @click="play(song)" style="border-radius: 40px; height: 50px; width: 50px;">
                                  &#9658;
                              </button>
                          </div>
                          <div class="col-md-6 col-lg-6 col-sm-6 text-right mr-0">
                              <div class="row">
                                  <div class="col">



                                      <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" class="add-to-playlist mt-2" @click="showAllPlaylists(song.id)"
                                           width="30" height="30"
                                           viewBox="0 0 225 225"
                                           style=" fill:#000000;">
                                          <g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal">
                                              <path d="M0,225.99419v-225.99419h225.99419v225.99419z" fill="none"></path><g fill="#ffffff">
                                              <path d="M21.59672,22.06364c-5.14747,-0.01432 -10.0867,2.03141 -13.7166,5.68113c-0.57512,0.57302 -1.11268,1.18254 -1.60933,1.82476c-0.88833,1.15403 -0.67294,2.80968 0.48108,3.69802c1.15403,0.88833 2.80968,0.67294 3.69802,-0.48108c0.35789,-0.46221 0.74522,-0.90085 1.15957,-1.31321c2.6431,-2.6572 6.23938,-4.14659 9.98726,-4.13618h167.06686c7.77465,0.03631 14.05806,6.34913 14.05806,14.12387c0,7.77474 -6.28341,14.08756 -14.05806,14.12387h-167.06686c-4.36478,0.01409 -8.48762,-2.00355 -11.15456,-5.45883c-0.89884,-1.13214 -2.54164,-1.32949 -3.68304,-0.44244c-1.1414,0.88705 -1.35577,2.52772 -0.4806,3.67826c3.66254,4.74489 9.32422,7.51561 15.3182,7.49646h167.06686c10.68266,-0.04257 19.32016,-8.71456 19.32016,-19.39731c0,-10.68275 -8.6375,-19.35473 -19.32016,-19.39731zM5.06659,36.82566c-1.38288,-0.05733 -2.57472,0.96435 -2.72942,2.33974c-0.18393,1.52512 -0.18393,3.06682 0,4.59194c0.161,1.32209 1.28255,2.31661 2.6144,2.31829c0.1073,-0.00016 0.2145,-0.00675 0.32101,-0.01974c1.44553,-0.17566 2.47499,-1.48986 2.2994,-2.93541c-0.13242,-1.10211 -0.13242,-2.21611 0,-3.31821c0.09602,-0.73369 -0.12067,-1.47396 -0.59716,-2.04007c-0.47649,-0.56611 -1.16892,-0.90595 -1.90823,-0.93654zM21.59672,79.5968c-10.68268,0.04254 -19.32021,8.71454 -19.32021,19.39731c0,10.68277 8.63753,19.35477 19.32021,19.39731h122.56022c-6.00038,5.0377 -10.67337,11.47043 -13.60931,18.73426h-108.9509c-6.94839,-0.02767 -13.38084,3.66337 -16.86305,9.67629c-3.48221,6.01291 -3.48221,13.42913 0,19.44204c3.48221,6.01291 9.91466,9.70396 16.86305,9.67629h110.24523c7.99724,16.50833 24.72042,26.99927 43.06383,27.01521c26.44032,-0.03001 47.86695,-21.45664 47.89696,-47.89696c-0.00173,-16.48564 -8.48138,-31.81178 -22.4473,-40.57131c6.6444,-5.02803 9.33605,-13.73733 6.68717,-21.63749c-2.64888,-7.90017 -10.04661,-13.22655 -18.37903,-13.23294zM21.59672,84.87024h167.06686c6.53191,0.00121 12.21125,4.48038 13.73461,10.83217c1.52336,6.35179 -1.50654,12.91971 -7.32735,15.88349c-0.89926,-0.40461 -1.81094,-0.78101 -2.73371,-1.12867c-0.55298,-0.21143 -1.10983,-0.4126 -1.67026,-0.60339c-0.95938,-0.34019 -1.92949,-0.64934 -2.9088,-0.92697c-0.53547,-0.14523 -1.07343,-0.28115 -1.61362,-0.40769c-0.99649,-0.24458 -2.00067,-0.45669 -3.01094,-0.63601c-0.58228,-0.09748 -1.16632,-0.18418 -1.75181,-0.26007c-0.95334,-0.13301 -1.91051,-0.23691 -2.87018,-0.31156c-0.70099,-0.04863 -1.40297,-0.08182 -2.10542,-0.09956c-0.49999,-0.0314 -1.00045,-0.05487 -1.50118,-0.07038c-0.37326,0.01194 -0.74636,0.02825 -1.11923,0.04892c-0.79088,0.02362 -1.58105,0.06684 -2.36978,0.1296c-0.80942,0.05357 -1.61735,0.12769 -2.423,0.2223c-0.76754,0.10103 -1.53251,0.22066 -2.29425,0.35877c-0.81475,0.13635 -1.62583,0.29376 -2.43244,0.47207c-0.73713,0.17343 -1.47005,0.36431 -2.19813,0.57249c-0.81538,0.22144 -1.62477,0.46443 -2.42729,0.7287c-0.70229,0.24211 -1.39885,0.50053 -2.08912,0.77505c-0.79881,0.30493 -1.58931,0.63121 -2.37064,0.97847c-0.66328,0.30567 -1.31949,0.62648 -1.9681,0.96216c-0.49997,0.23402 -0.99586,0.47667 -1.48744,0.72784h-130.12877c-5.06168,0.02362 -9.749,-2.66319 -12.28668,-7.04284c-2.53768,-4.37964 -2.53768,-9.78242 0,-14.16206c2.53768,-4.37964 7.225,-7.06646 12.28668,-7.04284zM174.90406,112.41503c0.00372,0 0.00744,0 0.01116,0c23.52558,0.03187 42.58742,19.09794 42.61408,42.62352c-0.03392,20.71648 -14.95849,38.40866 -35.37307,41.93266c-20.41458,3.524 -40.4068,-8.14079 -47.38402,-27.647c-0.21067,-0.61513 -0.40727,-1.23499 -0.58966,-1.85909c-0.22894,-0.72497 -0.43844,-1.45594 -0.62828,-2.19212c-0.15648,-0.66487 -0.29699,-1.3334 -0.42143,-2.005c-0.14909,-0.71863 -0.2796,-1.441 -0.39139,-2.16637c-0.0917,-0.69272 -0.16639,-1.38758 -0.22402,-2.08397c-0.07506,-0.71513 -0.13201,-1.43205 -0.1708,-2.15006c-0.02219,-0.70244 -0.02706,-1.40532 -0.01459,-2.108c-0.00348,-0.72238 0.0114,-1.44474 0.04463,-2.16636c0.04733,-0.68494 0.11114,-1.36863 0.1914,-2.0505c0.07029,-0.73893 0.15987,-1.47589 0.26865,-2.21014c0.11013,-0.64163 0.23491,-1.28067 0.37423,-1.9166c0.15072,-0.77108 0.32273,-1.53784 0.51584,-2.2994c0.15832,-0.56621 0.3283,-1.12909 0.50984,-1.68829c5.52213,-17.82953 22.00235,-29.99221 40.66744,-30.01328zM174.98217,127.37188c-0.71214,-0.02064 -1.40233,0.24778 -1.91341,0.74414c-0.51108,0.49636 -0.79954,1.17842 -0.7997,1.89086v22.39494h-22.39494c-1.45622,0 -2.63672,1.1805 -2.63672,2.63672c0,1.45622 1.1805,2.63672 2.63672,2.63672h22.39494v22.39408c0,1.45622 1.1805,2.63672 2.63672,2.63672c1.45622,0 2.63672,-1.1805 2.63672,-2.63672v-22.39408h22.39409c1.45622,0 2.63672,-1.1805 2.63672,-2.63672c0,-1.45622 -1.1805,-2.63672 -2.63672,-2.63672h-22.39409v-22.39494c-0.00033,-1.42623 -1.13469,-2.59368 -2.56033,-2.635zM21.59672,142.39912h107.09782c-0.08273,0.35558 -0.16141,0.71208 -0.23603,1.06945c-0.14564,0.60274 -0.27956,1.20824 -0.40169,1.81618c-0.18613,0.88535 -0.34727,1.77577 -0.48323,2.67019c-0.10932,0.75445 -0.20061,1.51141 -0.2738,2.27022c-0.08534,0.8119 -0.15002,1.62584 -0.19397,2.44103c-0.03585,0.80085 -0.05159,1.60248 -0.04721,2.40412c-0.00337,0.79479 0.01295,1.58954 0.04892,2.38352c0.04406,0.79397 0.10788,1.58672 0.1914,2.37751c0.07817,0.81664 0.17719,1.63116 0.29697,2.44274c0.11668,0.73803 0.25061,1.47323 0.40169,2.20499c0.16853,0.86139 0.36057,1.71802 0.57593,2.56891c0.17307,0.65305 0.35994,1.30236 0.56047,1.9475c0.14867,0.55325 0.30719,1.1038 0.4755,1.65139h-108.01277c-5.06168,0.02362 -9.749,-2.66319 -12.28668,-7.04284c-2.53768,-4.37964 -2.53768,-9.78242 0,-14.16206c2.53768,-4.37964 7.225,-7.06646 12.28668,-7.04284z">
                                              </path>
                                          </g></g>
                                      </svg>
                                  </div>
                                  <div class="col">
                                      <svg xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-star mt-2 ml-3" viewBox="0 0 16 16">
                                          <path d="M2.866 14.85c-.078.444.36.791.746.593l4.39-2.256 4.389 2.256c.386.198.824-.149.746-.592l-.83-4.73 3.522-3.356c.33-.314.16-.888-.282-.95l-4.898-.696L8.465.792a.513.513 0 0 0-.927 0L5.354 5.12l-4.898.696c-.441.062-.612.636-.283.95l3.523 3.356-.83 4.73zm4.905-2.767-3.686 1.894.694-3.957a.565.565 0 0 0-.163-.505L1.71 6.745l4.052-.576a.525.525 0 0 0 .393-.288L8 2.223l1.847 3.658a.525.525 0 0 0 .393.288l4.052.575-2.906 2.77a.565.565 0 0 0-.163.506l.694 3.957-3.686-1.894a.503.503 0 0 0-.461 0z"/>
                                      </svg>
                                  </div>
                              </div>


                          </div>
                      </div>

                  </div>
              </div>

          </div>
      </div>

      <router-view></router-view>
  </div>
</template>

<script>
export default {
    name: "Top",

    props: {
        playing: Boolean,
        activeSong: 0
    },

    data() {
        return {
            pager: {},
            index: 0,
            indexCurrentPage: 1,
            isPlaying: false,
            playlists: [],
            showPlaylists: false,
            current_button: 0
        }
    },

    created(){
        this.getRecommended();
        this.getPlaylists();
    },

    computed: {
        songs(){
            return this.pager.data || [];
        },
        // currentPage(){
        //     return this.indexCurrentPage = this.pager.current_page;
        // }
    },

    methods: {
        getRecommended(page = 1){
            axios
                .get('/api/recommended?page=' + page)
                .then(({data}) => {
                    this.pager = data;
                })
                .catch(error => console.log(error.response.data));
        },

        getPlaylists(){
            axios
                .get('/api/get/play-lists')
                .then(({data}) => {
                    this.playlists = data;
                })
                .catch(error => console.log(error.response.data));
        },

        play(song){
            this.index = song.id;
            this.$emit('play', { current: song, songs: this.songs });
        },

        pause(){
            this.$emit('pause');
        },

        showAllPlaylists(id){
          this.showPlaylists = true;
          this.current_button = id;
        },

        hidePlaylists(){
            this.showPlaylists = false;
        },

        addToPlaylist(songId, playlistId){
            axios
                .post('/api/add-to-playlist/'+playlistId+'/song/'+songId)
                .then(({data}) => {
                })
                .catch(error => console.log(error.response.data));
        }
    },

    watch:{
        playing: function (newVal, oldVal) {},

        activeSong: function (newVal, oldVal) {},
    }
}
</script>

<style scoped>
    .playlist {
        border: none;
    }
    .pl {
        position: relative;
        max-height: 180px;
        overflow: auto;
    }
</style>
